#include <alloc.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>
#include <stdio.h>
#include <dos.h>

typedef struct{
	int x, y;
}vectortype;

/**************************** declarations *****************************/
unsigned char readkbd(void);
void erase(int x1, int y1, int x2, int y2, int xoffset, int yoffset, unsigned char far *pic);
char touching(int x1, int y1, char *pic1, int x2, int y2, char *pic2, char mode);
void cls(void);
char load_font(unsigned char *name);
void unload_font(void);
void save_font(unsigned char *name);
void drawtext(int x, int y, unsigned char *string, unsigned char colour, char mode);
void loadpic(char far *image, int arraysize, unsigned char *filename);
void savepic(char far *image, int arraysize, unsigned char *filename);
void circle(int cx, int cy, int radius, unsigned char colour, char mode);
void put(int x1, int y1, unsigned char far *picture, char mode);
void get(int x1, int y1, int x2, int y2, unsigned char far *picture);
void box(int x1, int y1, int x2, int y2, int colour, char mode);
void line(int x1, int y1, int x2, int y2, unsigned char colour, char mode);
char getpixel(int x, int y);
char sgn(int val);
void putpixel(int x, int y, unsigned char colour, char mode);
void locate(char x, char y);
int mousex(void);
int mousey(void);
void showmouse(int onoff);
void initmouse(void);
char buttonpressed(void);
void initscrn(char mode);
void readmousediff(void);
char blackcharstatus(void);
void setmousepos(int x, int y);
void setmouselimits(int x1, int y1, int x2, int y2);
char turnoffmouse(void);
void palette(int c, char r, char g, char b);
char kbscan(void);
unsigned int counter(void);
char menuscreen(char *title, char *background, int numoptions, ...);
char choice(char *title, int numoptions, ...);
unsigned char *taketext(unsigned char *title, char *buttonused, char numbuttons, ...);
unsigned char choose(unsigned char *title, char numbuttons, ...);
void writebit(FILE *fout, char bitval);
char readbit(FILE *fin);
void rotput(int cx, int cy, int xoffset, int yoffset, float ang, float scale, unsigned char far *pic, char mode);
void roterase(int x1, int y1, int x2, int y2, int cx, int cy, float ang, float scale, unsigned char far * pic);
void scaleput(int x1, int y1, float xscale, float yscale, unsigned char far *pic, char mode);
void calcrotarea(int cx, int cy, int xoffset, int yoffset, float ang, float scale, unsigned char far *pic, int *x1, int *y1, int *x2, int *y2);
void calccorners(int cx, int cy, int xoffset, int yoffset, float ang, float scale, unsigned char far *pic, int *x1, int *y1, int *x2, int *y2, int *x3, int *y3, int *x4, int *y4);
void putfont(int x1, int y1, unsigned char far *picture, unsigned char colour, char mode);
unsigned char csmode(void);
void set_keyboard_rate(unsigned char rate, unsigned char delay);
void calccorners(int cx, int cy, int xoffset, int yoffset, float ang, float scale, unsigned char far *pic, int *x1, int *y1, int *x2, int *y2, int *x3, int *y3, int *x4, int *y4);
void drawpoly(int *x, int *y, unsigned char colour, char mode);
void hline(int x1, int x2, int y, unsigned char colour, char mode);
unsigned char getch();
unsigned char kbhit();
void drawchar(unsigned char c);
void handle_menu_IO(void);
void handle_option(int mop, int copt);
char current_option(int my, int menuy, int length);
char on_open_menu(int mx, int my, int menux, int menuy, int menuxsize, int menuysize);
void close_menu(char *undermenu, int menux, int menuy, int *menu_open);
void open_menu(int cm, char *undermenu, int *mnux, int *mnuy);
char current_menu(int mx, int my);
void load_menus(unsigned char *filename);
void drawmenus(void);
unsigned int maxmnuarea(void);

class buttonclass{
	private:
		int maxpicsize;
		unsigned char pic[226];

	public:
		int x1, y1, x2, y2;

		buttonclass(){
			maxpicsize = 226;
			pic[0] = pic[1] = 0;
			x1 = y1 = x2 = y2 = 0;
		}
		void load(unsigned char *picname){
			loadpic(pic, maxpicsize, picname);
			x2 = x1 + pic[0] - 1;
			y2 = y1 + pic[1] - 1;
		}
		void draw(char mode){ put(x1, y1, pic, mode); }
		void position(int x, int y){
			x1 = x; y1 = y;
			x2 = x1 + pic[0] - 1;
			y2 = y1 + pic[1] - 1;
		}
		char contains(int x, int y){
			char returnval = 1;
			returnval &= x >= x1;
			returnval &= x <= x2;
			returnval &= y >= y1;
			returnval &= y <= y2;
			return returnval;
		}
};

void draw_grid(void);
char on_grid(int x, int y);
void inccharindex(unsigned char *currentchar, char increment);
void draw_grid_contents(unsigned char currentchar);
void save_new_font_as(void);
void save_new_font(void);
void load_new_font(void);
void initialize_new_font(void);

/**************************** definitions ******************************/
#define tabsize 4
#define pi 3.141592654
#define maxmenus 3
#define maxmenuwidth 20
#define maxmenulength 20
#define menubordersize 2
#define textcolour 80
#define menucolour 20
#define shading 3
#define gridx 20
#define gridy 30
#define drawcharx 200
#define drawchary 0
#define drawcolour 3

/************************** Global Variables ***************************/
unsigned char far *vmem = (unsigned char far *)0xA0000000;
vectortype mousediff;
unsigned char far **font = NULL, xfontsize, yfontsize, nummenus = 0;
unsigned char menu[maxmenus][maxmenulength][maxmenuwidth], done = 0;
int menulength[maxmenus];
unsigned char far **newfont = NULL, newxfontsize, newyfontsize, oldfilename[256];
unsigned char hasname = 0, redraw_screen;
int gridscale = 8, gridcolour = 8;

void main(void){
	char smode;
	smode = csmode();
	initscrn(0x13);
	initmouse();
	if(load_font("normal.blf")){

		newfont = font;	/* load "normal.blf" into newfont as default */
		newxfontsize = xfontsize;
		newyfontsize = yfontsize;
		font = NULL;

		if(load_font("tiny.blf"))
			handle_menu_IO();
	}

	unload_font();
	font = newfont;
	unload_font();
	initscrn(smode);
}

void handle_menu_IO(void){
	/*** variables, etc. ***/
	int mx, my, menu_open = -1, intx, inty;
	unsigned char *undermenu, bp, onoff, currentchar = 0;
	int cm = -1, menux = 0, menuy = 0, n, x1, y1, x2, y2, numbuttons = 4;
	buttonclass button[4];

	/*** initialize / load / etc. stuff ***/
	load_menus("EDFONT.MNU");

	button[0].load("left.pic");
	button[1].load("right.pic");
	button[2].load("left2.pic");
	button[3].load("right2.pic");

	button[2].position(80, 0);
	button[0].position(button[2].x2 + 2, 0);
	button[1].position(button[0].x2 + 2, 0);
	button[3].position(button[1].x2 + 2, 0);

	undermenu = (unsigned char *)malloc((maxmnuarea() + 2) * sizeof(unsigned char));

	if(undermenu){
		showmouse(1);
		redraw_screen = 1;
		/*** main loop ***/
		while(!(done || kbhit())){
			if(redraw_screen){
				showmouse(0);
				cls();
				draw_grid();
				drawmenus();
				for(n = 0; n < numbuttons; n++)
					button[n].draw(0);
				redraw_screen = 0;
				showmouse(1);
				inccharindex(&currentchar, 0);
			}

			mx = mousex();
			my = mousey();
			bp = buttonpressed();
			if(bp){
				if((menu_open != -1) && on_open_menu(mx, my, menux, menuy, undermenu[0], undermenu[1])){

					int copt = current_option(my, menuy, menulength[menu_open]);
					int mop = menu_open;
					close_menu(undermenu, menux, menuy, &menu_open);
					handle_option(mop, copt);

					while(buttonpressed());
				}else{
					cm = current_menu(mx, my);

					if(cm == -1){ /*button pressed off the menu bar*/
						if(menu_open != -1)
							close_menu(undermenu, menux, menuy, &menu_open);

						/****** handle other mouse activity here ******/

						if(on_grid(mx, my)){
							/* button pressed on grid */
							onoff = (bp == 1);
							intx = (mx - gridx) / gridscale;
							inty = (my - gridy) / gridscale;
							newfont[currentchar][2 + intx + newxfontsize * inty] = onoff;
							putpixel(drawcharx + intx, drawchary + inty, drawcolour * onoff, 0);

							x1 = intx * gridscale + 1 + gridx;
							x2 = x1 + gridscale - 2;
							y1 = inty * gridscale + 1 + gridy;
							y2 = y1 + gridscale - 2;
							showmouse(0);
							box(x1, y1, x2, y2, onoff * 15, 0);
							showmouse(1);

						}else if(button[0].contains(mx, my))
							inccharindex(&currentchar, -1);
						else if(button[1].contains(mx, my))
							inccharindex(&currentchar, 1);
						else if(button[2].contains(mx, my))
							inccharindex(&currentchar, -10);
						else if(button[3].contains(mx, my))
							inccharindex(&currentchar, 10);

						/**********************************************/

					}else{ /*button pressed on the menu bar*/
						if(cm != menu_open){
							if(menu_open != -1)
								close_menu(undermenu, menux, menuy, &menu_open);

							showmouse(0);
							open_menu(cm, undermenu, &menux, &menuy);
							menu_open = cm;
							showmouse(1);
							while(buttonpressed());
						}
					}
				}
			}
		}
		showmouse(0);
		free(undermenu);
	}
}

void draw_grid(void){
	int x, y, n;

	x = gridx;
	for(n = 0; n <= newxfontsize; n++){
		box(x, gridy, x, gridy + gridscale * newyfontsize, gridcolour, 0);
		x += gridscale;
	}

	y = gridy;
	for(n = 0; n <= newyfontsize; n++){
		box(gridx, y, gridx + gridscale * newxfontsize, y, gridcolour, 0);
		y += gridscale;
	}
}

char on_grid(int x, int y){
	char returnval;
	returnval  = x >= gridx && x < gridx + gridscale * newxfontsize;
	returnval &= y >= gridy && y < gridy + gridscale * newyfontsize;
	return returnval;
}

void draw_grid_contents(unsigned char currentchar){
	int x, y, n, m;

	x = gridx;
	for(n = 0; n < newxfontsize; n++){
		y = gridy;
		for(m = 0; m < newyfontsize; m++){
			box(x + 1, y + 1,
				x + gridscale - 1,
				y + gridscale - 1,
				15 * newfont[currentchar][2 + n + newxfontsize * m],
				0);

			y += gridscale;
		}
		x += gridscale;
	}
}

void inccharindex(unsigned char *currentchar, char increment){
	unsigned int count = counter(), ui, n;
	unsigned char repeatdelaysize = 5, delaycount, chartodraw;
	do{
		delaycount = 0;
		*currentchar += increment;
		draw_grid_contents(*currentchar);

		/***** draw the charcter information at the top of the screen *****/
		ui = (unsigned int)*currentchar;
		ui %= 256;
		put(drawcharx, drawchary, newfont[ui], 0);
		for(n = 1; n < drawcolour; n++)
			put(drawcharx, drawchary, newfont[ui], 6);

		chartodraw = *currentchar;
		switch(chartodraw){ case 7:case 9:case 10:case 13: chartodraw = 32; }
		locate((drawcharx >> 3) + 2 + (newxfontsize >> 3), drawchary >> 3);
		printf("%c : %u  ", chartodraw, ui);

		/***** handle repetition delay *****/
		do{
			while(count == counter());
			count = counter();
			delaycount++;
		}while(delaycount < repeatdelaysize && buttonpressed());
		repeatdelaysize = 1;
	}while(buttonpressed());
}

void handle_option(int mop, int copt){

	if(!strcmp(menu[mop][copt], "Exit")) done = 1;
	else if(!strcmp(menu[mop][copt], "Save As..")) save_new_font_as();
	else if(!strcmp(menu[mop][copt], "Save")) save_new_font();
	else if(!strcmp(menu[mop][copt], "Load")) load_new_font();
	else if(!strcmp(menu[mop][copt], "New")) initialize_new_font();

}

void initialize_new_font(void){
	int n;
	unsigned char far **tmpfont, tmpxfontsize, tmpyfontsize, bad = 0, c;

	if(newfont){ /* unload current newfont */
		tmpfont = font;
		tmpxfontsize = xfontsize;
		tmpyfontsize = yfontsize;

		font = newfont;
		xfontsize = newxfontsize;
		yfontsize = newyfontsize;

		unload_font();

		font = tmpfont;
		xfontsize = tmpxfontsize;
		yfontsize = tmpyfontsize;
	}
	hasname = 0;

	/******** prompt for dimension of new font ************/
	showmouse(0);
	newxfontsize = atoi(taketext("How wide?", &c, 1, "Okay", 13));
	newyfontsize = atoi(taketext("How long?", &c, 1, "Okay", 13));
	showmouse(1);

	if(newxfontsize && newyfontsize){
		/******** allocate memory for new font *******/
		newfont = (unsigned char far **)farmalloc(256 * sizeof(char *));
		if(newfont){
			for(n = 0; n < 256; n++){
				newfont[n] = (char far *)malloc(newxfontsize * newyfontsize + 2);
				if(!newfont[n]) bad = 1;
				else{
					_fmemset(newfont[n], 0, newxfontsize * newyfontsize + 2);
					newfont[n][0] = newxfontsize;
					newfont[n][1] = newyfontsize;
				}
			}
			if(bad){
				for(n = 0; n < 256; n++)
					if(newfont[n]) farfree(newfont[n]);
				farfree(newfont);
				newfont = NULL;
			}
		}else bad = 1;
	}else bad = 1;

	if(bad){
		newxfontsize = newyfontsize = 0;
		newfont = NULL;
	}else{
		gridscale = 160 / newyfontsize;
		n = 280 / newxfontsize;
		if(n < gridscale) gridscale = n;
	}
	redraw_screen = 1;
}

void load_new_font(void){
	unsigned char **tmpfont, tmpxfontsize, tmpyfontsize;
	unsigned char tempfilename[256], newfilename[256], c;
	//int n;
	showmouse(0);
	strcpy(newfilename, taketext("File name:", &c, 2, "Okay", 13, "Cancel", 27));
	if(!c){ /* okay button has been pressed */
		tmpfont = font;
		tmpxfontsize = xfontsize;
		tmpyfontsize = yfontsize;
		strcpy(tempfilename, oldfilename);

		font = newfont;
		xfontsize = newxfontsize;
		yfontsize = newyfontsize;
		unload_font();

		load_font(newfilename);
		if(font){
			strcpy(oldfilename, newfilename);
			hasname = 1;
		}else{
			if(hasname){
				load_font(tempfilename);
				strcpy(oldfilename, tempfilename);
			}else
				load_font("normal.blf");
		}
		newfont = font;
		newxfontsize = xfontsize;
		newyfontsize = yfontsize;

		font = tmpfont;
		xfontsize = tmpxfontsize;
		yfontsize = tmpyfontsize;
	}
	showmouse(1);

	redraw_screen = 1;
}

void save_new_font(void){
	unsigned char **tmpfont, tmpxfontsize, tmpyfontsize;

	if(!hasname) save_new_font_as();
	else{
		/* shuffle fonts around */
		tmpfont = font;
		tmpxfontsize = xfontsize;
		tmpyfontsize = yfontsize;
		font = newfont;
		xfontsize = newxfontsize;
		yfontsize = newyfontsize;

		save_font(oldfilename);

		/* move fonts back to original spots */
		font = tmpfont;
		xfontsize = tmpxfontsize;
		yfontsize = tmpyfontsize;
	}
}

void save_new_font_as(void){
	unsigned char **tmpfont, tmpxfontsize, tmpyfontsize;
	unsigned char newfilename[256], c;
	//FILE *fout;

	showmouse(0);
	strcpy(newfilename, taketext("Save as...", &c, 2, "Okay", 13, "Cancel", 27));

	if(!c){ /* okay button has been pressed */
		/* shuffle fonts around */
		tmpfont = font;
		tmpxfontsize = xfontsize;
		tmpyfontsize = yfontsize;
		font = newfont;
		xfontsize = newxfontsize;
		yfontsize = newyfontsize;

		save_font(newfilename);

		/* move fonts back to original spots */
		font = tmpfont;
		xfontsize = tmpxfontsize;
		yfontsize = tmpyfontsize;

		strcpy(oldfilename, newfilename);
		hasname = 1;
	}
	showmouse(1);
}

char current_option(int my, int menuy, int length){
	char n = 0;
	int y;

	for(y = menuy + 2; (n <= length) && (y < my); n++)
		y += yfontsize;

	if((n > length) || (n == 0)) return 0;
	else return n;
}

char on_open_menu(int mx, int my, int menux, int menuy,
				 int menuxsize, int menuysize)
{
	char returnval = 0;
	if((mx >= menux) && (mx < menux + menuxsize))
		if((my >= menuy) && (my < menuy + menuysize))
			returnval = 1;
	return returnval;
}

void close_menu(char *undermenu, int menux, int menuy, int *menu_open){
	*menu_open = -1;
	showmouse(0);
	put(menux, menuy, undermenu, 0);
	showmouse(1);
}

void open_menu(int cm, char *undermenu, int *mnux, int *mnuy){
	int n, xsize = 0, ysize, menux = (xfontsize >> 1), menuy = 0, x, y;

	/*** determine X size of menu ***/
	for(n = 1; n <= menulength[cm]; n++)
		if(strlen(menu[cm][n]) > xsize) xsize = strlen(menu[cm][n]);
	xsize *= xfontsize;
	xsize += menubordersize * 2;

	/*** determine Y size of menu ***/
	ysize = (menulength[cm] * yfontsize) + menubordersize * 2;

	/*** determine X, Y locations of the menu ***/
	for(n = 0; n < cm; n++)
		menux += xfontsize * (strlen(menu[n][0]));
	menuy = yfontsize;

	/*** draw the menu ***/
	get(menux, menuy, menux + xsize - 1, menuy + ysize - 1, undermenu);
	box(menux, menuy, menux + xsize - 1, menuy + ysize - 1, 0, 0);
	x = menux + menubordersize;
	y = menuy + menubordersize;
	for(n = 1; n <= menulength[cm]; n++){
		drawtext(x, y, menu[cm][n], textcolour, 4);
		y += yfontsize;
	}
	box(menux, menuy, menux, menuy + ysize - 1, menucolour + shading, 0);
	box(menux, menuy, menux + xsize - 1, menuy, menucolour + shading, 0);
	box(menux + xsize - 1, menuy, menux + xsize - 1, menuy + ysize - 1, menucolour - shading, 0);
	box(menux, menuy + ysize - 1, menux + xsize - 1, menuy + ysize - 1, menucolour - shading, 0);
	box(menux, menuy, menux + xsize - 1, menuy + ysize - 1, menucolour, 5);
	*mnux = menux;
	*mnuy = menuy;
}

char current_menu(int mx, int my){
	int n, xmenusize = menubordersize;
	int ymenusize = yfontsize + menubordersize * 2;
	char returnval = 0;

	if(my < ymenusize){
		for(n = 0; n < nummenus; n++){
			xmenusize += xfontsize * (strlen(menu[n][0]));
			if((xmenusize - (xfontsize >> 1)) < mx) returnval++;
		}
		if(returnval == nummenus) returnval = -1;
	}
	else returnval = -1;

	return returnval;
}

unsigned int maxmnuarea(void){
	unsigned int xsize, ysize, memsize, n, m;

	xsize = ysize = 0;

	for(n = 0; n < nummenus; n++){
		if(menulength[n] > ysize) ysize = menulength[n];
		for(m = 0; m < menulength[n]; m++){
			if(strlen(menu[n][m]) > xsize) xsize = strlen(menu[n][m]);
		}
	}
	xsize *= xfontsize;
	ysize *= yfontsize;
	xsize += menubordersize * 2;
	ysize += menubordersize * 2;
	memsize = xsize * ysize;
	return memsize;

}

void drawmenus(void){
	int n, xmenusize = menubordersize;
	int ymenusize = yfontsize + menubordersize * 2;

	for(n = 0; n < nummenus; n++){
		box(xmenusize - (xfontsize >> 1) + 1, 0, xmenusize - (xfontsize >> 1) + 1, ymenusize - 1, menucolour + shading, 0);
		drawtext(xmenusize, menubordersize, menu[n][0], textcolour, 4);
		xmenusize += xfontsize * (strlen(menu[n][0]));
		box(xmenusize - (xfontsize >> 1), 0, xmenusize - (xfontsize >> 1), ymenusize - 1, menucolour - shading, 0);
	}
	xmenusize -= (xfontsize >> 1) - 1;

	box(xmenusize - 1, 1, xmenusize - 1, ymenusize - 1, menucolour - shading, 5);
	box(1, ymenusize - 1, xmenusize - 1, ymenusize - 1, menucolour - shading, 5);
	box(0, 0, xmenusize - 1, 0, menucolour + shading, 5);
	box(0, 0, 0, ymenusize - 1, menucolour + shading, 5);
	box(0, 0, xmenusize - 1, ymenusize - 1, menucolour, 5);


}

void load_menus(unsigned char *filename){
	int n, m;
	char numstring[5];
	FILE *menufile;

	/***** get the number of menus ********/
	menufile = fopen(filename, "r");
	nummenus = atoi(fgets(numstring, 5, menufile));

	/***** load each menu ********/
	for(n = 0; n < nummenus; n++){
		fgets(menu[n][0], maxmenuwidth, menufile);
		menulength[n] = atoi(fgets(numstring, 5, menufile));
		for(m = 1; m <= menulength[n]; m++){
			fgets(menu[n][m], maxmenuwidth, menufile);
			menu[n][m][strlen(menu[n][m]) - 1] = (char)0;
		}
	}
	fclose(menufile);
}

/**************************** Keyboard I/O *****************************/
void set_keyboard_rate(unsigned char rate, unsigned char delay){
	delay %= 4;
	rate %= 32;
	asm{
		mov ah, 0x3
		mov al, 0x5
		mov bh, delay
		mov bl, rate
		int 0x16
	}
}

unsigned char readkbd(void){
	if(!kbhit()) asm int 9; /* kills keyboard delay */
	if(kbhit())
		return getch();
	else
		return NULL;
}

char blackcharstatus(void){
	char returnval;
	asm{
		mov ah, 0x2
		int 0x16
		mov returnval, al
	}
	return returnval;
}

char kbscan(void){
	return inp(0x60);
}

unsigned char getch(){
	unsigned char returnval;
	asm{
		mov ah, 0x8
		int 0x21
		mov returnval, al
	}
	return returnval;
}

unsigned char kbhit(){
	unsigned char returnval;
	asm{
		mov ah, 0xB
		int 0x21
		mov returnval, al
	}
	returnval = returnval != 0;
	return returnval;
}

void drawchar(unsigned char c){
	asm{
		mov ah, 0x2
		mov dl, c
		int 0x21
	}
}

/**************************** Mouse I/O *****************************/
void readmousediff(void){
	int x, y;
	asm{
		mov ax, 0xB
		int 0x33
		mov x, cx
		mov y, dx
	}
	mousediff.x = x;
	mousediff.y = y;
}

char buttonpressed(void){
	int returnval;
	asm{
		mov ax, 0x3
		int 0x33
		mov returnval, bx
	}
	return returnval;
}

int mousex(void){
	int returnval;
	asm{
		mov ax, 0x3
		int 0x33
		mov returnval, cx
	}
	return returnval >> 1;
}

int mousey(void){
	int returnval;
	asm{
		mov ax, 0x3
		int 0x33
		mov returnval, dx
	}
	return returnval;

}

void initmouse(void){
	asm{
		mov ax, 0
		int 0x33
	}
}

void showmouse(int onoff){
	onoff = (onoff == 0) + 1;
	asm{
		mov ax, onoff
		int 0x33
	}
}

char turnoffmouse(void){
	int returnval;
	asm{
		mov ax, 0x1F
		int 0x33
		mov returnval, ax
	}
	return returnval;
}

void setmousepos(int x, int y){
	asm{
		mov ax, 0x4
		mov cx, x
		shl cx, 1
		mov dx, y
		int 0x33
	}
}

void setmouselimits(int x1, int y1, int x2, int y2){
	asm{
		/*********** set x range **********/
		mov ax, 0x7
		mov cx, x1
		mov dx, x2
		shl cx, 1
		shl dx, 1
		int 0x33

		/*********** set y range **********/
		mov ax, 0x8
		mov cx, y1
		mov dx, y2
		int 0x33
	}
}

/****************************** Misc ******************************/
void locate(char x, char y){
	asm{
		mov ah, 2
		mov dh, y
		mov dl, x
		mov bh, 0
		int 0x10
	}
}

char sgn(int val){
	if(val > 0) return 1;
	return -(val < 0);
}

unsigned int counter(void){
	return peek(0x40, 0x6C);
}

void set_count_rate(int rate){
	_asm cli
	if(rate < 19) rate = 19;
	rate = (rate == 18) ? 0 : ((unsigned int) (1193180L / ((unsigned long)rate)));
	asm{
		mov dx, 0x43
		mov al, 0x34
		out dx, al
		mov dx, 0x40
		mov ax, rate
		out dx, al
		mov al, ah
		out dx, al
		sti
	}
}

/****************************** Graphics ******************************/
void initscrn(char mode){
	asm{
		mov ah, 0
		mov al, mode
		int 0x10
	}
}

unsigned char csmode(void){
	unsigned char returnval;
	asm{
		mov ah, 0xF
		int 0x10
		mov returnval, al
	}
	return returnval;
}

void putpixel(int x, int y, unsigned char colour, char mode){
	if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
		switch(mode){
			case 0: vmem[(y << 8) + (y << 6) + x]  = colour; break;
			case 1: vmem[(y << 8) + (y << 6) + x] ^= colour; break;
			case 2: vmem[(y << 8) + (y << 6) + x] |= colour; break;
			case 3: vmem[(y << 8) + (y << 6) + x] &= colour; break;
			case 4:
				if(colour) vmem[(y << 8) + (y << 6) + x] = colour;
				break;
			case 5:
				if(!vmem[(y << 8) + (y << 6) + x])
					vmem[(y << 8) + (y << 6) + x] = colour;
				break;
			case 6: vmem[(y << 8) + (y << 6) + x] += colour; break;
		}
}

char getpixel(int x, int y){
	if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
		return vmem[(y << 8) + (y << 6) + x];
	else
		return 0;
}

void line(int x1, int y1, int x2, int y2, unsigned char colour, char mode){
	int i, dx, dy, sdx, sdy, dxabs, dyabs, x, y, px, py;

	dx = x2 - x1;
	dy = y2 - y1;
	dxabs = abs(dx);
	dyabs = abs(dy);
	sdx = sgn(dx);
	sdy = sgn(dy);
	x = dyabs >> 1;
	y = dxabs >> 1;
	px = x1;
	py = y1;

	putpixel(px, py, colour, mode);

	if (dxabs >= dyabs){
		for(i = 0; i < dxabs; i++){
			y += dyabs;
			if (y >= dxabs){
				y -= dxabs;
				py += sdy;
			}
			px += sdx;
			putpixel(px, py, colour, mode);
		}
	}else{
		for(i = 0; i < dyabs; i++){
			x += dxabs;
			if(x >= dyabs){
				x -= dyabs;
				px += sdx;
			}
			py += sdy;
			putpixel(px, py, colour, mode);
		}
	}
}

void box(int x1, int y1, int x2, int y2, int colour, char mode){
	int x, y, n;
	if(x1 < 0) x1 = 0; if(x1 > 319) x1 = 319;
	if(y1 < 0) y1 = 0; if(y1 > 199) y1 = 199;
	if(x2 < 0) x2 = 0; if(x2 > 319) x2 = 319;
	if(y2 < 0) y2 = 0; if(y2 > 199) y2 = 199;
	if(x1 > x2) { x1 ^= x2; x2 ^= x1; x1 ^= x2; }
	if(y1 > y2) { y1 ^= y2; y2 ^= y1; y1 ^= y2; }

	if(mode == 4){
		for(x = x1; x <= x2; x++){
			vmem[(y1 << 8) + (y1 << 6) + x] = colour;
			vmem[(y2 << 8) + (y2 << 6) + x] = colour;
		}
		for(y = y1; y <= y2; y++){
			vmem[(y << 8) + (y << 6) + x1] = colour;
			vmem[(y << 8) + (y << 6) + x2] = colour;
		}

	}else{
		for(x = x1; x <= x2; x++){
			for(y = y1; y <= y2; y++){
				switch(mode){
					case 0: vmem[(y << 8) + (y << 6) + x]  = colour; break;
					case 1:	vmem[(y << 8) + (y << 6) + x] ^= colour; break;
					case 2: vmem[(y << 8) + (y << 6) + x] |= colour; break;
					case 3: vmem[(y << 8) + (y << 6) + x] &= colour; break;
					case 5:
						n = (y << 8) + (y << 6) + x;
						vmem[n] += (!vmem[n]) * colour;
					break;
					case 6: vmem[(y << 8) + (y << 6) + x] += colour; break;
				}
			}
		}
	}
}

void palette(int c, char r, char g, char b){
	r %= 64;
	g %= 64;
	b %= 64;
	asm{
		mov ah, 0x10
		mov al, 0x10
		mov bx, c
		mov ch, g
		mov cl, b
		mov dh, r
		int 0x10
	}
}

void cls(void){
	_fmemset(vmem, 0, 64000);
}

void drawtext(int x, int y, unsigned char *string, unsigned char colour, char mode){
	int length = strlen(string), n, initx = x;
	unsigned char charval, repeat;

	for(n = 0; n < length; n++){
		do{
			charval = string[n];
			repeat = 1;
			switch(charval){
				case '\r':
					x = initx; /** please note: break is gone for a reason. */
				case '\n':
					y += yfontsize;
					break;
				case '\t':
					x += tabsize * xfontsize;
					break;
				case '\b':
					x -= xfontsize;
					break;
				case '\v':
					y += 4 * yfontsize;
					break;
				default:
					repeat = 0;
			}
			n += repeat;
		}while(repeat);
		putfont(x, y, font[charval], colour, mode);
		x += xfontsize;
	}
}

void get(int x1, int y1, int x2, int y2, unsigned char far *picture){
	int n = 2, x, y;
	if(x1 > x2){ x1 ^= x2; x2 ^= x1; x1 ^= x2; }
	if(y1 > y2){ y1 ^= y2; y2 ^= y1; y1 ^= y2; }

	picture[0] = x2 - x1 + 1;
	picture[1] = y2 - y1 + 1;
	for(y = y1; y <= y2; y++){
		for(x = x1; x <= x2; x++){
			if((x >= 0) || (x <= 319) || (y >= 0) || (y <= 199))
				picture[n] = vmem[(y << 8) + (y << 6) + x];
			else
				picture[n] = 0;

			n++;
		}
	}
}

void putfont(int x1, int y1, unsigned char far *picture, unsigned char colour, char mode){
	int n = 2, x, y;
	unsigned int dy, madd;
	int x2 = x1 + picture[0] - 1;
	int y2 = y1 + picture[1] - 1;
	mode %= 7;
	for(y = y1; y <= y2; y++){
		if(y >= 0 && y <= 199){
			dy = (y << 8) + (y << 6);
			for(x = x1; x <= x2; x++){
				if((x >= 0) && (x <= 319)){
					madd = dy + x;
					switch(mode){
						case 0: vmem[madd]  = (picture[n] != 0) * colour; break;
						case 1: vmem[madd] ^= (picture[n] != 0) * colour; break;
						case 2: vmem[madd] |= (picture[n] != 0) * colour; break;
						case 3: vmem[madd] &= (picture[n] != 0) * colour; break;
						case 4:
							if(picture[n] != 0)
								vmem[madd] = (picture[n] != 0) * colour;
							break;
						case 5:
							if(vmem[madd] == 0)
								vmem[madd] = (picture[n] != 0) * colour;
							break;
						case 6: vmem[madd] += (picture[n] != 0) * colour; break;
					}
				}
				n++;
			}
		}
	}
}

void put(int x1, int y1, unsigned char far *picture, char mode){
	int n = 2, x, y;
	int x2 = x1 + picture[0] - 1;
	int y2 = y1 + picture[1] - 1;

	switch(mode){
		case 0:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[(y << 8) + (y << 6) + x]  = picture[n];
					n++;
				}
		break;
		case 1:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[(y << 8) + (y << 6) + x] ^= picture[n];
					n++;
				}
		break;
		case 2:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[(y << 8) + (y << 6) + x] |= picture[n];
					n++;
				}
		break;
		case 3:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[(y << 8) + (y << 6) + x] &= picture[n];
					n++;
				}
		break;
		case 4:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if(picture[n] != 0)
						if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
							vmem[(y << 8) + (y << 6) + x] = picture[n];
					n++;
				}
		break;
		case 5:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						if(vmem[(y << 8) + (y << 6) + x] == 0)
							vmem[(y << 8) + (y << 6) + x] = picture[n];
					n++;
				}
		break;
		case 6:
			for(y = y1; y <= y2; y++)
				for(x = x1; x <= x2; x++){
					if((x >= 0) && (x <= 319) && (y >= 0) && (y <= 199))
						vmem[(y << 8) + (y << 6) + x] += picture[n];
					n++;
				}
		break;
	}
}

/****************************** File I/O ******************************/
void writebit(FILE *fout, char bitval){
	static unsigned char bit[8], numbits = 0;
	unsigned char byte, n;

	if(bitval == -1){ /* force write despite numbits < 8 */
		for(;numbits < 8; numbits++)
			bit[numbits] = 0;
	}else{
		bit[numbits] = (bitval != 0);
		numbits++;
	}

	if(numbits >= 8){
		byte = 0;
		for(n = 0; n < 8; n++){
			if(bit[n])
				byte += 1 << (7 - n);
		}
		fputc(byte, fout);
		numbits = 0;
	}
}

char readbit(FILE *fin){
	char returnval = 0;
	static unsigned char byte, bitsleft = 0;


	if(!feof(fin) || bitsleft){
		if(bitsleft == 0){
			byte = fgetc(fin);
			bitsleft = 8;
		}

		bitsleft--;
		if(byte >=  (1 << bitsleft)){
			byte -= (1 << bitsleft);
			returnval = 1;
		}
		return returnval;
	}else{
		return -1;
	}
}

void save_font(unsigned char *name){
	int c, n;
	FILE *fout;

	if(font){
		fout = fopen(name, "wb");

		fputc(xfontsize, fout);
		fputc(yfontsize, fout);

		for(c = 0; c < 256; c++){
			for(n = 2; n < (xfontsize * yfontsize + 2); n++){
				//fputc(font[c][n], fout);
				writebit(fout, font[c][n] != 0);
			}
		}
		writebit(fout, -1);

		fclose(fout);
	}
}

void unload_font(void){
	int n;
	if(font){
		for(n = 0; n < 256; n++)
			if(font[n])
				free(font[n]);
		free(font);
		font = NULL;
	}
}

char load_font(unsigned char *name){
	int c, n, bad = 0;
	FILE *fname;
	fname = fopen(name, "rb");

	xfontsize = fgetc(fname);
	yfontsize = fgetc(fname);

	/******* free previously loaded font *******/
	if(font != NULL) unload_font();

	/******** allocate memory for new font *******/
	font = (unsigned char far **)farmalloc(256 * sizeof(char *));
	if(font){
		for(n = 0; n < 256; n++){
			font[n] = (char far *)farmalloc(xfontsize * yfontsize + 2);
			if(!font[n]) bad = 1;
		}
		if(bad){
			for(n = 0; n < 256; n++)
				if(font[n]) farfree(font[n]);
			farfree(font);
			font = NULL;
		}
	}else bad = 1;

	/******** load new font **********/
	for(c = 0; (c < 256) && !bad; c++){
		font[c][0] = xfontsize;
		font[c][1] = yfontsize;
		for(n = 2; n < (xfontsize * yfontsize + 2); n++){
			font[c][n] = readbit(fname);
		}
	}
	fclose(fname);

	return (!bad);
}

void savepic(char far *image, int arraysize, unsigned char *filename){
	int n;
	FILE *picfile;
	picfile = fopen(filename, "wb");
	n = image[0] * image[1] + 2;
	if(arraysize < n) n = arraysize;
	fwrite((void *)image, 1, n, picfile);
	fclose(picfile);
}

void loadpic(char far *image, int arraysize, unsigned char *filename){
	int size;
	FILE *picfile;
	picfile = fopen(filename, "rb");

	image[0] = fgetc(picfile);
	image[1] = fgetc(picfile);
	size = image[0] * image[1] + 2;
	if(size > arraysize) size = arraysize;
	size -= 2;
	fread((void *)&image[2], 1, size, picfile);
	fclose(picfile);
}

/**************************** user I/O *******************************/
unsigned char choose(unsigned char *title, char numbuttons, ...){
	typedef struct{
		char *text, character;
		int x1, x2, y1, y2;
	}buttontype;

	unsigned char memgood, *underbox, fini = 0;
	unsigned char keypressed, buttonused;
	buttontype *button;
	va_list arg_list;
	int buttonswidth, titlewidth;
	int n, boxwidth, boxx1, boxx2, boxy1, boxy2, x, y;

	/***** allocate enough memory to store all of the buttons *****/
	n = (4 * sizeof(int) + sizeof(char *) + sizeof(char)) * numbuttons;
	button = (buttontype *)malloc(n);
	memgood = ((button != NULL) || (n == 0));

	/***** read the various arguments *****/
	va_start(arg_list, numbuttons);
	for(n = 0; n < numbuttons; n++){
		button[n].text = strdup(va_arg(arg_list, char *));
		button[n].character = va_arg(arg_list, char);
		if(button[n].text == NULL) memgood = 0;
	}
	va_end(arg_list);

	/***** calculate collective width of buttons *****/
	if(memgood){
		buttonswidth = xfontsize;
		for(n = 0; n < numbuttons; n++){
			buttonswidth += (strlen(button[n].text) + 1) * xfontsize;
		}
	}
	boxwidth = buttonswidth;

	titlewidth = (strlen(title) + 2) * xfontsize;
	if(boxwidth < titlewidth) boxwidth = titlewidth;

	/***** calculate size and location of box *****/
	boxx1 = 160 - (boxwidth / 2);
	boxx2 = boxx1 + boxwidth - 1;
	boxy1 = 100 - 2 * yfontsize;
	boxy2 = boxy1 + 4 * yfontsize - 1;

	underbox = (char *)malloc((boxx2 - boxx1 + 1) * (boxy2 - boxy1 + 1) + 2);
	memgood *= (underbox != NULL);

	if(memgood){
		/***** get the image beneath the box *****/
		showmouse(0);
		get(boxx1, boxy1, boxx2, boxy2, underbox);

		/***** draw the box *****/
		box(boxx1, boxy1, boxx2 - 1, boxy2 - 1, 22, 4);
		box(boxx1 + 1, boxy1 + 1, boxx2, boxy2, 18, 4);
		box(boxx1 + 1, boxy1 + 1, boxx2 - 1, boxy2 - 1, 20, 0);

		/***** determine the locations of, and draw, the buttons *****/
		x = 160 - buttonswidth / 2;
		for(n = 0; n < numbuttons; n++){
			x += xfontsize;
			button[n].x1 = x - 2;
			x += (xfontsize * strlen(button[n].text));
			button[n].x2 = x + 2;
			button[n].y2 = boxy2 - (yfontsize >> 1) + 1;
			button[n].y1 = button[n].y2 - yfontsize - 2;
			box(button[n].x1 + 1, button[n].y1 + 1, button[n].x2, button[n].y2, 18, 4);
			box(button[n].x1, button[n].y1, button[n].x2 - 1, button[n].y2 - 1, 22, 4);
			box(button[n].x1 + 1, button[n].y1 + 1, button[n].x2 - 1, button[n].y2 - 1, 20, 0);
			drawtext(button[n].x1 + 2, button[n].y1 + 1, button[n].text, 15, 4);
		}

		/***** draw the title *****/
		drawtext(160 - titlewidth / 2 + xfontsize, boxy1 + (yfontsize >> 1), title, 15, 4);

		showmouse(1);
		while(!fini){
			/***** handle keyboard IO *****/
			if(kbhit()){

				keypressed = getch();

				/***** test for hotkeys *****/
				for(n = 0; n < numbuttons && !fini; n++){
					if(keypressed == button[n].character){
						fini = 1;
						buttonused = n;
					}
				}
			}

			/***** handle mouse IO *****/
			if(buttonpressed()){
				x = mousex();
				y = mousey();
				for(n = 0; n < numbuttons; n++){
					if((button[n].x1 <= x) && (button[n].x2 >= x) &&
					   (button[n].y1 <= y) && (button[n].y2 >= y))
						break;
				}
				if(n < numbuttons){
					fini = 1;
					buttonused = n;
				}
			}
		}
		showmouse(0);
		put(boxx1, boxy1, underbox, 0);
		showmouse(1);
	}

	for(n = 0; n < numbuttons; n++)
		if(button[n].text) free(button[n].text);
	if(button) free(button);
	if(underbox) free(underbox);

	return buttonused;
}

unsigned char *taketext(unsigned char *title, char *buttonused, char numbuttons, ...){
	typedef struct{
		char *text, character;
		int x1, x2, y1, y2;
	}buttontype;

	const int maxstringlength = 1024;
	unsigned char returnval[1024], memgood, *underbox, fini = 0;
	unsigned char keypressed, *drawstring, insertmode = 1;
	buttontype *button;
	va_list arg_list;
	int buttonswidth, titlewidth;
	int n, boxwidth, boxx1, boxx2, boxy1, boxy2, x, y;
	int textx1, textx2, texty, displaywidth, stringlength;
	int coffset, doffset;

	/***** allocate enough memory to store all of the buttons *****/
	n = (4 * sizeof(int) + sizeof(char *) + sizeof(char)) * numbuttons;
	button = (buttontype *)malloc(n);
	memgood = ((button != NULL) || (n == 0));

	/***** read the various arguments *****/
	va_start(arg_list, numbuttons);
	for(n = 0; n < numbuttons; n++){
		button[n].text = strdup(va_arg(arg_list, char *));
		button[n].character = va_arg(arg_list, char);
		if(button[n].text == NULL) memgood = 0;
	}
	va_end(arg_list);

	/***** calculate collective width of buttons *****/
	if(memgood){
		buttonswidth = xfontsize;
		for(n = 0; n < numbuttons; n++){
			buttonswidth += (strlen(button[n].text) + 1) * xfontsize;
		}
	}
	boxwidth = buttonswidth;

	titlewidth = (strlen(title) + 2) * xfontsize;
	if(boxwidth < titlewidth) boxwidth = titlewidth;

	/***** calculate size and location of box *****/
	boxx1 = 160 - (boxwidth / 2);
	boxx2 = boxx1 + boxwidth - 1;
	if(numbuttons){
		boxy1 = 100 - 3 * yfontsize;
		boxy2 = boxy1 + 6 * yfontsize - 1;
	}else{
		boxy1 = 100 - 2 * yfontsize;
		boxy2 = boxy1 + 4 * yfontsize - 1;
	}

	underbox = (char *)malloc((boxx2 - boxx1 + 1) * (boxy2 - boxy1 + 1) + 2);
	memgood *= (underbox != NULL);

	if(memgood){
		/***** get the image beneath the box *****/
		get(boxx1, boxy1, boxx2, boxy2, underbox);

		/***** draw the box *****/
		box(boxx1, boxy1, boxx2 - 1, boxy2 - 1, 22, 4);
		box(boxx1 + 1, boxy1 + 1, boxx2, boxy2, 18, 4);
		box(boxx1 + 1, boxy1 + 1, boxx2 - 1, boxy2 - 1, 20, 0);

		/***** determine the locations of, and draw, the buttons *****/
		x = 160 - buttonswidth / 2;
		for(n = 0; n < numbuttons; n++){
			x += xfontsize;
			button[n].x1 = x - 2;
			x += (xfontsize * strlen(button[n].text));
			button[n].x2 = x + 2;
			button[n].y2 = boxy2 - (yfontsize >> 1) + 1;
			button[n].y1 = button[n].y2 - yfontsize - 2;
			box(button[n].x1 + 1, button[n].y1 + 1, button[n].x2, button[n].y2, 18, 4);
			box(button[n].x1, button[n].y1, button[n].x2 - 1, button[n].y2 - 1, 22, 4);
			box(button[n].x1 + 1, button[n].y1 + 1, button[n].x2 - 1, button[n].y2 - 1, 20, 0);
			drawtext(button[n].x1 + 2, button[n].y1 + 1, button[n].text, 15, 4);
		}

		/***** draw the title *****/
		drawtext(160 - titlewidth / 2 + xfontsize, boxy1 + (yfontsize >> 1), title, 15, 4);

		/***** draw the text box *****/
		n = boxx2 - boxx1 - 2 * xfontsize;
		n -= (n % xfontsize);
		textx1 = 160 - n / 2;
		textx2 = textx1 + n;
		displaywidth = n / xfontsize;
		drawstring = (char *)malloc(displaywidth + 1);
		memgood = drawstring != NULL;

		if(numbuttons)
			texty = button[0].y1 - 1.5 * yfontsize;
		else
			texty = boxy2 - 1.5 * yfontsize;
		box(textx1 - 2, texty - 2, textx2 + 1, texty + yfontsize + 1, 18, 0);
		box(textx1 - 1, texty - 1, textx2 + 2, texty + yfontsize + 2, 22, 0);
		box(textx1 - 1, texty - 1, textx2 + 1, texty + yfontsize + 1, 0, 0);

		showmouse(1);
		memset(returnval, NULL, maxstringlength);
		coffset = doffset = stringlength = 0;
		while(!fini && drawstring){
			/***** handle keyboard IO *****/
			if(kbhit()){
				/***** hide the cursor *****/
				box(textx1 + xfontsize * (stringlength + coffset - doffset), texty,
					textx1 + xfontsize * (stringlength + coffset - doffset) + (xfontsize - 2) * (1 - insertmode), texty + yfontsize - 1,
					0, 0);

				keypressed = getch();

				/***** test for hotkeys *****/
				for(n = 0; n < numbuttons && !fini; n++){
					if(keypressed == button[n].character){
						fini = 1;
						*buttonused = n;
					}
				}
				/***** test for other keys *****/
				if(!fini){
					switch(keypressed){
						case 0:
							switch(getch()){
								case 'G': //home
									coffset = -stringlength;
								break;
								case 'O':
									coffset = 0;
								break;
								case 'K': //left
									if(- coffset < stringlength)
										coffset--;
								break;
								case 'M': //right
									if(coffset < 0)
										coffset++;
								break;
								case 83: //del
									if(- coffset > 0){
										for(n = coffset; n < 0; n++)
											returnval[stringlength + n] = returnval[stringlength + n + 1];
										stringlength--;
										coffset++;
										returnval[stringlength] = NULL;
									}
								break;
								case 82: //insert
									insertmode = 1 - insertmode;
								break;
							}
						break;
						case 8: //backspace
							if(- coffset < stringlength){
								for(n = coffset; n < 0; n++)
									returnval[stringlength + n - 1] = returnval[stringlength + n];
								stringlength--;
								returnval[stringlength] = NULL;
							}
						break;
						case 13: //enter
							*buttonused = 0;
							fini = 1;
						break;
						default: //alphanumagrammatic characters
							if((keypressed >= 32) && (keypressed <= 126) && (stringlength < maxstringlength)){
								if(insertmode)
									for(n = 0; n > coffset; n--)
										returnval[stringlength + n] = returnval[stringlength + n - 1];

								returnval[stringlength + coffset] = keypressed;

								if(insertmode || coffset == 0)
									stringlength++;
								else
									coffset++;
							}
					}
				}

				/***** redraw the string *****/
				n = stringlength + coffset;
				if(n > doffset + displaywidth - !insertmode)
					doffset = n - displaywidth + !insertmode;
				if(n < doffset)
					doffset = n;

				memset(drawstring, 32, displaywidth + 1);
				drawstring[displaywidth] = NULL;
				strncpy(drawstring, &returnval[doffset], displaywidth);
				for(n = 0; n < displaywidth; n++)
					if(drawstring[n] == NULL) drawstring[n] = 32;

				showmouse(0);
				drawtext(textx1, texty, drawstring, 15, 0);

				/***** draw the cursor *****/
				box(textx1 + xfontsize * (stringlength + coffset - doffset), texty,
					textx1 + xfontsize * (stringlength + coffset - doffset) + (xfontsize - 2) * (1 - insertmode), texty + yfontsize - 1,
					14, 1);
				showmouse(1);
			}

			/***** handle mouse IO *****/
			if(buttonpressed()){
				x = mousex();
				y = mousey();
				for(n = 0; n < numbuttons; n++){
					if((button[n].x1 <= x) && (button[n].x2 >= x) &&
					   (button[n].y1 <= y) && (button[n].y2 >= y))
						break;
				}
				if(n < numbuttons){
					fini = 1;
					*buttonused = n;
				}
			}
		}
		showmouse(0);

		put(boxx1, boxy1, underbox, 0);
	}

	for(n = 0; n < numbuttons; n++)
		if(button[n].text) free(button[n].text);
	if(button) free(button);
	if(underbox) free(underbox);
	if(drawstring) free(drawstring);

	return returnval;
}